=== debian/changelog ===
node-quickjs-emscripten (0.23.0+dfsg-5) unstable; urgency=medium

  [ Yadd ]
  * Declare compliance with policy 4.7.0

  [ Jérémy Lal ]
  * Allow rebuild without clean
  * Reenable supported emcc flags. Closes: #1084307
  * DEP-3 format

 -- Jérémy Lal <kapouer@melix.org>  Mon, 14 Apr 2025 12:39:16 +0200

node-quickjs-emscripten (0.23.0+dfsg-4) unstable; urgency=medium

  * Limit tests to little-endian only

 -- Yadd <yadd@debian.org>  Thu, 19 Oct 2023 12:55:15 +0400

node-quickjs-emscripten (0.23.0+dfsg-3) unstable; urgency=medium

  * Update lintian override info format in d/source/lintian-overrides
    on line 2.
  * Increase test timeout for buggy arm* platforms

 -- Yadd <yadd@debian.org>  Wed, 13 Sep 2023 14:15:16 +0400

node-quickjs-emscripten (0.23.0+dfsg-2) unstable; urgency=medium

  * Team upload
  * Increase test timeout

 -- Yadd <yadd@debian.org>  Fri, 18 Aug 2023 12:25:02 +0400

node-quickjs-emscripten (0.23.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #1043231)

 -- Israel Galadima <izzygaladima@gmail.com>  Mon, 07 Aug 2023 14:09:18 +0000
