=== debian/control ===
Source: node-quickjs-emscripten
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Israel Galadima <izzygaladima@gmail.com>
Build-Depends:
 debhelper-compat (= 13)
 , dh-sequence-nodejs
 , dh-nodejs
 , node-ts-node
 , mocha
 , node-typescript
 , node-source-map-support
 , wget
 , emscripten
 , node-fs-extra
Standards-Version: 4.7.0
Homepage: https://github.com/justjake/quickjs-emscripten#readme
Vcs-Git: https://salsa.debian.org/js-team/node-quickjs-emscripten.git
Vcs-Browser: https://salsa.debian.org/js-team/node-quickjs-emscripten
Rules-Requires-Root: no

Package: node-quickjs-emscripten
Architecture: all
Depends:
 ${misc:Depends}
 , nodejs:any
Description: Javascript/Typescript bindings for QuickJS compiled to WebAssembly
 Safely execute untrusted Javascript in your Javascript,
 and execute synchronous code that uses async functions.
 Create and manipulate values inside the QuickJS runtime.
 Expose host functions to the QuickJS runtime.
 .
 Node.js is an event-based server-side JavaScript engine.
