=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

#override_dh_auto_build:

override_dh_installdocs:
	dh_installdocs
	dh_nodejs_autodocs

override_dh_installexamples:
	dh_installexamples
	find debian/*/usr/share/doc/node-quickjs-emscripten/examples -name package-lock.json -delete
	find debian/*/usr/share/doc/node-quickjs-emscripten/examples -name yarn.lock -delete
	find debian/*/usr/share/doc/node-quickjs-emscripten/examples -name .gitignore -delete
